#include <stdlib.h>								// Standard Library
#include <soft_serout.h>							// For SLCD Module
#include <sleep.h>								// For Delay
#include <serial.h>								// For Recieve Data from Remote Control
#include <sound.h>								// For Generate Sound
#include <motor.h>								// For Control Motor

unsigned char key,flag=0;
unsigned char dec[4],bin[9];

void main()
{
	sleep(1000);									// Delay 1 Sec
	soft_serout_init(0,9600);						// Initial Serial Comm 9600 8N1
	uart_set_baud(1200);							// Set IR remote control Baudrate	
	sound(2000,200);								// Status Sound
	serout_byte(0,0xFE);serout_byte(0,0x01);		// Clear Screen SLCD
	serout_byte(0,0xFE);serout_byte(0,0x80);		// Show Text on First Line
	serout_text(0,"You Press Key ");

	while(1)									// Infinite Loop
	{
		key=uart_getkey(20000);						// read key from remote control 33 mS
		if ((key!=flag)&&(key>0x40)&&(key<0x7F))		// Test Key in Range and not same key
		 {
			serout_byte(0,0xFE);
			serout_byte(0,0x8E);						// Show on SLCD
			serout_byte(0,key);						
			flag=key;					
		}
	}
}
