#include <stdlib.h>									// Standard Library
#include <soft_serout.h>								// For SLCD Module
#include <sleep.h>									// For Delay
#include <serial.h>									// For Recieve Data from Remote Control
#include <sound.h>									// For Generate Sound
#include <motor.h>									// For Control Motor
	
unsigned char key,flag=0;

void main()
{
	sleep(1000);										// 	Delay 1 Sec
	soft_serout_init(0,9600);								// 	Initial Serial Comm 9600 8N1
	uart_set_baud(1200);								// 	Set IR remote control Baudrate	
	sound(2000,200);									// 	Status Sound
	serout_byte(0,0xFE);serout_byte(0,0x01);		//	Clear Screen SLCD
	serout_byte(0,0xFE);serout_byte(0,0x80);		//  Show Text on First Line
	serout_text(0,"Press any IR Key");

	while(1)												// Infinite Loop
	{
		key=uart_getkey(65000);								//	waiting and read key from remote control 33 mS
			if ((key=='a')||(key=='A'))					// "A" key for Backward
			{ 
				backward(100);
				if (flag!=1)								// Show "Backward" on SLCD  first time only	
				{
					serout_byte(0,0xFE);
					serout_byte(0,0xC0);
					serout_text(0,"Backward  ");
					flag=1;
				}
			}
			else if ((key=='d')||(key=='D'))			// "D" key for Forward
			{ 
				forward(100); 	
				if (flag!=2)								// Show "Forward" on SLCD  first time only	
				{
					serout_byte(0,0xFE);		
					serout_byte(0,0xC0);
					serout_text(0,"Forward   ")	;
					flag=2;
				}
			}
			else if ((key=='c')||(key=='C'))		// "C" key for Forward	
			{ 
				s_left(100); 
				if (flag!=3)							// Show "Turn Left" on SLCD  first time only
				{
					serout_byte(0,0xFE);
					serout_byte(0,0xC0);
					serout_text(0,"Turn Left ");	
					flag=3;
				}
			}
			else if ((key=='b')||(key=='B'))		// "D" key for Forward	
			{ 
				s_right(100); 
				if (flag!=4)							// Show "Turn Right" on SLCD  first time only	
				{
					serout_byte(0,0xFE);
					serout_byte(0,0xC0);
					serout_text(0,"Turn Right");
					flag=4;
				}
			}
			else
			{motor_off();flag=0;}					// Stop Motor if no key press	
	}
}
